proc TracePrgCheck {name element op} {
global Process Obj_WinProj Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

#	puts "TracePrgCheck $numproj : $Process(proj,checking,$trace_id)"
        if [info exists Obj_WinProj($numproj,wstatus)] {
		show-status "$Process(proj,checking,$trace_id) ..." $Obj_WinProj($numproj,wstatus)
	}
#	WinLib_UpdateWinTextChk $numlib
}
proc TraceProjListSelectTargets {name element op} {
global Process Obj_WinProj Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

	switch -glob -- $Process(proj,selectfiles,$trace_id,status) {

		  {*off*}	{PRINT "Selection Off"}

		  {*running*}  {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state disabled
				}
			       }

		  {*done*}     {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Get the selected files
				set Obj_Proj($numproj,$prg,target) $Process(proj,selectfiles,$trace_id,value)
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectTargets
				# Save Definitions
				SavePrgDef $numproj $prg
				# Update Infos
				WinProj_UpdateWPrgInfo $numproj $prg
			       }

		  {*cancel*}   {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectTargets
			       }

		  default      {
				# Hum... I thought that we could never reach that case ???
				PRINT "*** TkfPW WARNING : Selection Status Unknown !!!"
				PRINT "*** $Process(proj,selectfiles,$trace_id,status)"
				PRINT "*** It seems that TkfPW needs improvments..."
			       }
	}

}

proc TraceProjListSelectLibUsr {name element op} {
global Process Obj_WinProj Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

	switch -glob -- $Process(proj,selectfiles,$trace_id,status) {

		  {*off*}	{PRINT "Selection Off"}

		  {*running*}  {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state disabled
				}
			       }

		  {*done*}     {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Get the selected files
				set Obj_Proj($numproj,$prg,libusr) $Process(proj,selectfiles,$trace_id,value)
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectLibUsr
				# Save Definitions
				SavePrgDef $numproj $prg
				# Update Infos
				WinProj_UpdateWPrgInfo $numproj $prg
			       }

		  {*cancel*}   {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectLibUsr
			       }

		  default      {
				# Hum... I thought that we could never reach that case ???
				PRINT "*** TkfPW WARNING : Selection Status Unknown !!!"
				PRINT "*** $Process(proj,selectfiles,$trace_id,status)"
				PRINT "*** It seems that TkfPW needs improvments..."
			       }
	}

}

proc TraceProjListSelectSharedLib {name element op} {
global Process Obj_WinProj Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

	switch -glob -- $Process(proj,selectfiles,$trace_id,status) {

		  {*off*}	{PRINT "Selection Off"}

		  {*running*}  {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state disabled
				}
			       }

		  {*done*}     {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Get the selected files
				set Obj_Proj($numproj,$prg,libcom) $Process(proj,selectfiles,$trace_id,value)
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectSharedLib
				# Save Definitions
				SavePrgDef $numproj $prg
				# Update Infos
				WinProj_UpdateWPrgInfo $numproj $prg
			       }

		  {*cancel*}   {
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,selectfiles,$trace_id,status) w TraceProjListSelectSharedLib
			       }

		  default      {
				# Hum... I thought that we could never reach that case ???
				PRINT "*** TkfPW WARNING : Selection Status Unknown !!!"
				PRINT "*** $Process(proj,selectfiles,$trace_id,status)"
				PRINT "*** It seems that TkfPW needs improvments..."
			       }
	}

}
proc TraceProjSelCompOpt {name element op} {
global Process Obj_WinProj Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

	switch -glob -- $Process(proj,selectopts,$trace_id) {

		  {*off*}	{PRINT "Selection of Compiler Options is Off"}

		  {*running*}  {
				foreach button {wbutdefine wbutdelete} {
					$Obj_WinProj($numproj,$button) configure -state disabled
				}
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state disabled
				}
			       }

		  {*done*}     {
				foreach button {wbutdefine wbutdelete} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,selectopts,$trace_id) w TraceProjSelCompOpt
			       }

		  {*cancel*}   {
				foreach button {wbutdefine wbutdelete} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,selectopts,$trace_id) w TraceProjSelCompOpt
			       }

		  default      {
				# Hum... I thought that we could never reach that case ???
				PRINT "*** TkfPW WARNING : Selection of Compiler Options Status Unknown !!!"
				PRINT "*** $Process(proj,selectopts,$trace_id)"
				PRINT "*** It seems that TkfPW needs improvments..."
			       }
	}

}
proc TraceProjCompil {name element op} {
global Process Obj_WinProj Obj_Dir Obj_Proj

	set trace_id [ lindex [split $element ","] 2]
	set numproj	[ lindex [split $trace_id ":"] 0]
	set prg		[ lindex [split $trace_id ":"] 1]

	switch -glob -- $Process(proj,compiling,$trace_id) {

 		  {*off*}	{PRINT "Compilation is Off"}

		  {*running*} {PRINT "Compilation is running"
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state disabled
				}
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state disabled
				}
			      }

		  {*kill*}    { PRINT "Compilation is Killed"
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state normal
				}
				# Update Infos
#puts "getinfo kill"
 				GetInfoProj $numproj
				GetInfoPrg $numproj $Obj_Proj($numproj) $prg
				WinProj_UpdateWPrgInfo $numproj $prg
				# Update the File Error Window Container
				WinProj_UpdateWinText $numproj
				# Update the Target List Files Container
				WinProj_ShowFiles_update $numproj
				# Stop the trace
        			trace vdelete Process(lib,compiling,$trace_id) w TraceProjCompil
			      }

		  {*done*}    {PRINT "Compilation is Done"
				foreach button {wbutdefine wbutdelete wbutupdate wbutrun} {
					$Obj_WinProj($numproj,$button) configure -state normal
				}
				# Reset the action button
				WinProj_BuildPrg_wbutaction $numproj $prg DISABLED
				# Move the Object Modules into the Builder Directory
				set projpath $Obj_Dir(Proj)/$Obj_Proj($numproj)
				catch { eval exec mv [glob $projpath/Src/*.o] $projpath/Builder }
				# Linking the Program
				MakeLinkProgram $numproj $prg
				WinProj_BuildPrg_wbutaction $numproj $prg NORMAL
				# Update Infos
				WinProj_UpdateWPrgInfo $numproj $prg
				# Update the Target Selection frame
				WinProj_BuildPrg_seltarget $numproj $prg
				# Update the File Error Window Container
				WinProj_UpdateWinText $numproj
				# Update the Target List Files Container
				WinProj_ShowFiles_update $numproj
				foreach button {wbutselcopt wbutclose} {
					$Obj_WinProj($numproj,$prg,$button) configure -state normal
				}
				# Stop the trace
        			trace vdelete Process(proj,compiling,$trace_id) w TraceProjCompil
			      }

		  default     {
				# Hum... I thought that we could never reach that case ???
				PRINT "*** TkfPW WARNING : Compilation Status Unknown !!!"
				PRINT "*** $Process(lib,compiling,$trace_id)"
				PRINT "*** It seems that TkfPW needs improvments..."
			      }
	}

}
